---
layout: handbook-page-toc
title: CI Steps - Key Project Plan
description: Weekly Engineering Project plan for CI Steps
---

## On this page
{:.no_toc .hidden-md .hidden-lg}

- TOC
{:toc .hidden-md .hidden-lg}

## Weekly Project Plan

Epics:
- [Iteration 1: Bootstrap Step Runner (MVC)](https://gitlab.com/groups/gitlab-org/-/epics/11736)
- [Iteration 2: Support `run:` syntax in `.gitlab-ci.yml` (MVP)](https://gitlab.com/groups/gitlab-org/-/epics/11846)

<details markdown="1">
<summary markdown="span">Past Milestones</summary>

### %16.5 

#### Week of 2023-09-17
- Engineering strategy meeting to discuss an initial iteration plan

#### Week of 2023-09-25
- Clarify the iteration plan and next steps, with estimates of:
  - Architectural Design doc updates to be merged in next 2-3 weeks
  - MVC to be completed in the next 2-3 months

#### Week of 2023-10-02
- Iterating on technical strategy in [Architectural blueprint](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)

#### Week of 2023-10-09
- Iterating on technical strategy in [Architectural blueprint](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)
- Designate a Pipeline Authoring (Rails) DRI to start collaborating with the Runner DRI

### %16.6 

#### Week of 2023-10-16
- Set up sync meeting between Engineering and Product to discuss current progress and align on technical & product strategy and goals
- [Iterate on the Architectural blueprint MR](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)

#### Week of 2023-10-23
- [Iterate on the Architectural blueprint MR](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)
- Bootstrap Step Runner MVC (Iteration 1)

#### Week of 2023-10-30
- [Iterate on the Architectural blueprint MR](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)
- Bootstrap Step Runner MVC (Iteration 1)

#### Week of 2023-11-06
- [Iterate on the Architectural blueprint MR](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)
- Bootstrap Step Runner MVC (Iteration 1)

### %16.7

#### Week of 2023-11-13
- [Iterate on the Architectural blueprint MR](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688)
- Bootstrap Step Runner MVC (Iteration 1)

#### Week of 2023-11-20
- [Resolved threads and merge the Architectural blueprint MR](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/131688) with defined data structures
- Bootstrap Step Runner MVC (Iteration 1)

</details>

### %16.7

#### Week of 2023-11-27
- [x] [Create `gitlab-org/step-runner`](https://gitlab.com/gitlab-org/gitlab/-/issues/425876)
- Merge a working POC for Step Runner MVC (Iteration 1)

#### Week of 2023-12-04
- Identify and resolve issues listed in https://gitlab.com/gitlab-org/step-runner/-/issues
- Start determining which teams internally could start dogfooding

### %16.8

#### Week of 2023-12-11
- Identify and resolve issues listed in [the list of step-runner issues](https://gitlab.com/gitlab-org/step-runner/-/issues)
- Recorded a [working demo of the Step Runner MVC](https://youtu.be/TU_53vWVKeE)

#### Week of 2023-12-18
- End of Year PTO 🎄  

#### Week of 2023-12-25
- End of Year PTO 🎄

#### Week of 2024-01-02
- Build example Step components for common functions: bash/power-shell scripts
- Work on [The Expression Language](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/138092)

#### Week of 2024-01-09
- Build example Step components for common functions: bash/power-shell scripts
- Work on [The Expression Language](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/138092)
- - Identify the parallel tracks of work that can taken on by Verify:Runner and Verify:Pipeline Authoring teams (16.9 or 16.10 starting)

#### Week of 2024-01-16
- Build example Step components for common functions: bash/power-shell scripts
- Work on [The Expression Language](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/138092)

### %16.9

#### Week of 2024-01-23
- Build example Step components for common functions: bash/power-shell scripts
- Work on [The Expression Language](https://gitlab.com/gitlab-org/gitlab/-/merge_requests/138092)

### Planned for 2024-02 and beyond (WIP)
- Build out a few more officially supported steps, such as fetch sources, caching, artifacts. (scope TBD)
- Create a runner feature flag to skip built-in steps.
- Implement GitLab CI Steps support in Rails (working with Verify:Pipeline Authoring). This will elevate the "steps in env variable" to a properly supported syntax, including CI Editor support.
- Add more test coverage (unit tests, integration tests, e2e tests (and for each engine)). Up until this point, test coverage is expected to be minimal.
- Build support for GitHub Actions in CI Steps (up until this point, only GitLab-based steps will be supported)
- Setup publishing workflows for Step Runner and all the officially supported engines and steps. Because users will be referencing our steps directly in their workflows, we need to publish them.
 - Write clear documentation on how how users should import steps. E.g. which ones need docker, what the recommended use is, etc... I don't think the Component Catalog will be ready to curate these yet, but we can at least have some nice README's when browsing our steps sub-group.
